<?php

class onelink
{

 function onelink($type, $input)
 { // constructor
  global $db, $settings, $linkownerarray; 
  $linklist = explode(',', $settings->linkfields);  
  if ($type == 'blank')
  {
   $row = $input;
   $num = sizeof($row);
   for ($count=0; $count<$num; $count++)
   {
	$this->$linklist[$count] = '';
   }  
   $this->url = 'http://';
   $this->id = 1;
  }
  else if ($type == 'row')
  {
   $row = $input;
   $num = sizeof($row);
   for ($count=0; $count<$num; $count++)
   {
	$this->$linklist[$count] = stripcode($row[$count]);
   }  
  }
  else if ($type == 'new')
  {
   $num = sizeof($linklist);
   for ($count=0; $count<$num; $count++)
   {
    global $$linklist[$count];
   }
   for ($count=0; $count<$num; $count++)
   {
    $$linklist[$count] = $$linklist[$count];
    if ($$linklist[$count] == 'on')
	$this->$linklist[$count] = 'yes';
    else if ($$linklink[$count] == 'off')
	$this->$linklist[$count] = 'no';
    else
	$this->$linklist[$count] = encodeit($$linklist[$count]);
   }  
  }   
  else
  {
   $linkid = $input;
   $linkdata = $db->select($settings->linkfields, 'linkstable', "id=$linkid", '', '');
   $row = $db->row($linkdata);
   $num = sizeof($row);
   for ($count=0; $count<$num; $count++)
   {
 	 $this->$linklist[$count] = $row[$count];
   }
  }
  if (($type != 'new') && ($type != 'blank')) $linkownerarray[$this->id] = $this->ownerid;
 }

 
 function update($fields)
 {
  global $db, $settings, $language;
  if ($fields == 'all') $linklist = explode(',', $settings->linkfields);
  else $linklist = explode(',', $fields);
  $num = sizeof($linklist);
  for ($count=0; $count<$num; $count++)
  {
   if ($linklist[$count] == 'recip')
   {
    if ($this->recip == 'yes') $this->recip = 1;
    if ($this->recip == 'no') $this->recip = 0;	
   }
   if ($linklist[$count] == 'hide')
   {
    if ($this->hide == 'yes') $this->hide = 1;
    if ($this->hide == 'no') $this->hide = 0;	
   }
   $result = $db->update('linkstable', $linklist[$count], encodeit($this->$linklist[$count]), 'id='. $this->id);
  }
 }
 
 function add()
 {
  global $db, $settings, $language;
  $linkstuff = $settings->linkfields;
  $linklist = explode(',', $linkstuff);
  $num = sizeof($linklist);
  for ($count=0; $count<$num; $count++)
  {
   $starttoadd = "'";
   $middletoadd = $this->$linklist[$count];
   if ($linklist[$count] == 'time') $middletoadd = time();
   if ($linklist[$count] == 'lastedit') $middletoadd = time();
   if ($linklist[$count] == 'votes') $middletoadd = '0';
   if ($linklist[$count] == 'rating') $middletoadd = '0';   
   if ($linklist[$count] == 'hide') $middletoadd = '0';
   $endtoadd = "'";
   $valuetoadd = $starttoadd . $middletoadd . $endtoadd;
   $valuelist .= $valuetoadd; 
   if ($count<($num-1)) $valuelist .= ',';
  }
  $result = $db->insert('linkstable', $settings->linkfields, $valuelist);
  $adminaddress = $settings->email;
  if ( ($settings->notify == 'yes') && ($this->validated != 1) && ($settings->email != '') )
  {  
   $q = $db->select('id', 'linkstable', 'time='. $this->time, '', '');
   $this->id = $db->rowitem($q);
   $subject = $language->email_newsuggestiontitle;
   $message = $language->email_newsuggestionbody;
   $message = str_replace('{TYPE}', 'link', $message); 
   $message = str_replace('{DIRURL}', $settings->dirurl, $message);
   $message = linkreplacements($message, $this);
   sendemail("$adminaddress", "$subject", "$message", "From: $adminaddress");
  } 
 }
 
 function deletethis()
 {
  global $db;
  $id = $this->id;
  $result = $db->delete('linkstable', "id=$id");
  $result = $db->delete('commentstable', "linkid=$id"); // delete all of this link's' comments
  return $result;
 }

 function reject($reason)
 {
  global $db, $settings, $language;
  $id = $this->id;
  $result = $db->delete('linkstable', "id=$id");
  $result = $db->delete('commentstable', "linkid=$id"); // delete all of this link's comments
  if ($this->email != '')
  {
   $subject = linkreplacements($language->email_rejectsubject, $this);
   $message = linkreplacements($language->email_rejectbody, $this);
   $message = str_replace('{REASON}', $reason, $message);
   sendemail($this->email, $subject, $message, 'From: '. $settings->email);
  }
  return $result;
 }
 
 function validate()
 { 
  global $db;
  $this->validated = 1;
  if ($this->email != '') sendvalidationemail($this);
  $this->update('validated');
  return true;
 }
 
 function thedate()
 {
  global $language;
  setlocale(LC_ALL, $language->dateformat_locale);  
   if (!$this->time) return '';  
  $dateformat = $language->dateformat_regular;
  $thedate = strftime("$dateformat", $this->time);
  if ($this->time == 0) $thedate = '';
  return $thedate;
 }

function lasteditdate()
{
global $language;
setlocale(LC_ALL, $language->dateformat_locale); 
if (!$this->lastedit) return '';
$dateformat = $language->dateformat_regular;
$lasteditdate = strftime("$dateformat", $this->lastedit);
if (($this->lastedit == 0) || ($this->lastedit == $this->time)) $lasteditdate = '';
return $lasteditdate; 
}
 
}

?>