<?php
include 'start.php';
$area = $language->title_divider . $language->title_search; // supply area for template
$search = stripcode($search);
if (($whichtype == 'entries') || ($whichtype == 'links') || !$whichtype)
{
 $realtype = 'entries';
 $whichtype = 'links';
}
else 
{
 $realtype = $whichtype;
}

if ($condition == '') $condition = 'like';

if ($action == 'advanced')
{
 if ($filled)
 {
  if (!$template)
  {
   if ($realtype == 'entries') { $template = new template('search.tpl'); $linkfields = $settings->linkfields; }
   if ($whichtype == 'comments') { $template = new template('searchcomments.tpl'); $linkfields = $settings->commentfields; }
   if ($whichtype == 'members') { $template = new template('searchmembers.tpl'); $linkfields = $settings->memberfields; }
  }
  if ($whichtype == 'comments') $template->replace('{LANG_SEARCH_COMMENTFROM}', $language->search_commentfrom);
  if ($page=='') $page = 1;
  $start = ($page * $perpage) - $perpage;
  if ($perpage=='') $perpage = $settings->perpage;
  if ($searchfields == '') 
  { 
   $searchfields = $settings->searchfields;
   $searchfields = explode(',', $searchfields);
  }
  if (is_array($searchfields))
  {
   $num = sizeof($searchfields);
  $generatesearch = '(validated=1';
  if (($whichtype == 'links') || ($whichtype == 'categories')) $generatesearch .=' AND hide=0';
  $generatesearch .= ') AND (';
  if ($settings->condition != '') $generatesearch .= $settings->condition .' AND ';
  for ($count=0; $count<$num; $count++)
  {
   if ($condition == 'or')
   {
    $searchwords = explode(' ', $search);
    $num = sizeof($searchwords);
    for ($count=0; $count<$num; $count++)
    {
     $searchitem = $searchwords[$count];
     $generatesearch .= "$searchfields[$count] LIKE '%$searchitem%'";
     if ($count < ($num-1)) $generatesearch .= " OR ";
    }
   }
   else
   {
    $generatesearch .= "$searchfields[$count] ";
    if ($condition == 'like') $generatesearch .= "LIKE '%$search%'";
    else $generatesearch .= "$condition '$search'";
    if ($count < ($num-1)) $generatesearch .= " OR ";
   }
  }
  $generatesearch .= ')';
  }
  else
  {
  $generatesearch = '(validated=1';
  if ((($whichtype == 'links')) && ($searchfields != 'hide')) $generatesearch .= ' AND hide=0';
  $generatesearch .= ') AND (';
  if ($settings->condition != '') $generatesearch .= $settings->condition .' AND ';
  if ($condition == 'like') $generatesearch .= "$searchfields LIKE '%$search%'";
  else if ($condition == 'or')
  {
   $searchwords = explode(' ', $search);
   $num = sizeof($searchwords);
   for ($count=0; $count<$num; $count++)
   {
    $searchitem = $searchwords[$count];
    $generatesearch .= "$searchfields LIKE '%$searchitem%'";
    if ($count < ($num-1)) $generatesearch .= " OR ";
   }
  }
  else $generatesearch .= "$searchfields $condition '$search'";
  $generatesearch .= ')';
  }
  if ($whichtype == '') $whichtype = 'links'; // allow comment or member searches, but entries are default
  $getnumber = $db->select($linkfields, $whichtype.'table', "$generatesearch", '', '');
  $numresults = $db->numrows($getnumber); 
  $dosearch = $db->select($linkfields, $whichtype.'table', "$generatesearch", '', "LIMIT $start,$perpage");
  $num = $db->numrows($dosearch);
  $searchbody = templateextract($template->text, "<!-- BEGIN SEARCH $realtype RESULTS -->", "<!-- END SEARCH $realtype RESULTS -->");
  $template->replace($searchbody, '{RESULTS}'); // replace with marker
  $removeothers = templateextract($template->text, "<!-- BEGIN SEARCH entries RESULTS -->", "<!-- END SEARCH entries RESULTS -->");
  if ($whichtype != 'links') $template->replace($removeothers, '');
  $removeothers = templateextract($template->text, "<!-- BEGIN SEARCH members RESULTS -->", "<!-- END SEARCH members RESULTS -->");
  if ($whichtype != 'members') $template->replace($removeothers, '');
  $removeothers = templateextract($template->text, "<!-- BEGIN SEARCH comments RESULTS -->", "<!-- END SEARCH comments RESULTS -->");
  if ($whichtype != 'comments') $template->replace($removeothers, '');
  for ($count=0; $count<$num; $count++)
  {  
   $row  =  $db->row($dosearch);
   if ($whichtype == 'links') $thelink = new onelink('row', $row); 
   else if ($whichtype == 'comments') $thelink = new comment('row', $row); 
   else if ($whichtype == 'members') $thelink = new member('row', $row);
   if ($whichtype == 'links') 
   {
    $results .= linkreplacements($searchbody, $thelink); 
   }
   else if ($whichtype == 'members') $results .= memberreplacements($searchbody, $thelink); 
   else if ($whichtype == 'comments') $results .= commentreplacements($searchbody, $thelink);     
  }  
  if ($numresults > 0)
  {
   $template->replace('{RESULTS}', $results);
  }
  else
   $template->replace('{RESULTS}', '');
  if ($searchfields[0] == 'ownerid')
  {
   $getname = new member('id', $search);
   $search = $getname->name;
  }
  $language->search_found = str_replace('{SEARCHTERM}', $search, $language->search_found);  
  if ($numresults == '')
    $template->replace('{LANG_SEARCH_FOUND}', str_replace('{NUMRESULTS}', '0', $language->search_found));
  else
    $template->replace('{LANG_SEARCH_FOUND}', str_replace('{NUMRESULTS}', $numresults, $language->search_found));	

  $template->replace('{SEARCHTERM}', $search);  
  $numpages = ceil($numresults / $perpage);
  $search = urlencode($search);
  for ($count=1; $count < $page; $count++)
    $previouspages .= $language->pageselection_left. "<a href=search.php?page=$count&perpage=$perpage&search=$search>$count</a>". $language->pageselection_right;
  for ($count=$page; $count<$numpages; $count++)
  {
    $next = $count+1;
    $nextpages .= $language->pageselection_left ."<a href=search.php?page=$next&perpage=$perpage&search=$search>$next</a>". $language->pageselection_right;
  }
  $template->replace('{PREVIOUS}', $previouspages);
  $template->replace('{NEXT}', $nextpages);
  $template->replace('{CURRENTPAGE}', $page);
  $template->replace('{PAGE}', $page);
  $template->replace('{PERPAGE}', $perpage);   
 }
 else
 {
  if (!$template) $template = new template('searchadvanced.tpl');
 }
}
else
{
 if (!$template)
 {
  if ($whichtype == 'comments') $template = new template('searchcomments.tpl');
  if ($whichtype == 'members') $template = new template('searchmembers.tpl');
  else $template = new template('search.tpl');
 }
 if ($page=='') $page = 1;
 $start = ($page * $perpage) - $perpage;
 if ($perpage=='') $perpage = $settings->perpage;
 if ($searchfields == '') 
 { 
  $searchfields = $settings->searchfields;
  $searchfields = explode(',', $searchfields);
 }
 $num = sizeof($searchfields);
 $generatesearch = '(validated=1 AND hide=0) AND (';
 if ($settings->condition != '') $generatesearch .= $settings->condition .' AND ';
 for ($count=0; $count<$num; $count++)
 {
  $generatesearch .= "$searchfields[$count] LIKE '%$search%'";
  if ($count < ($num-1)) $generatesearch .= " OR ";
 }
 $generatesearch .= ')';
 if ($whichtype == '') $whichtype = 'links'; // allow comment or member searches, but entries are default
 $getnumber = $db->select($linkfields, $whichtype.'table', "$generatesearch", '', '');
 $numresults = $db->numrows($getnumber); 
 $dosearch = $db->select($linkfields, $whichtype.'table', "$generatesearch", '', "LIMIT $start,$perpage");
 $num = $db->numrows($dosearch);
 $searchbody = templateextract($template->text, "<!-- BEGIN SEARCH $realtype RESULTS -->", "<!-- END SEARCH $realtype RESULTS -->");
 $template->replace($searchbody, '{RESULTS}'); // replace with marker
 $removeothers = templateextract($template->text, "<!-- BEGIN SEARCH entries RESULTS -->", "<!-- END SEARCH entries RESULTS -->");
 if ($whichtype != 'links') $template->replace($removeothers, '');
 $removeothers = templateextract($template->text, "<!-- BEGIN SEARCH members RESULTS -->", "<!-- END SEARCH members RESULTS -->");
 if ($whichtype != 'members') $template->replace($removeothers, '');
 $removeothers = templateextract($template->text, "<!-- BEGIN SEARCH comments RESULTS -->", "<!-- END SEARCH comments RESULTS -->");
 if ($whichtype != 'comments') $template->replace($removeothers, '');
 for ($count=0; $count<$num; $count++)
 {  
  $row  =  $db->row($dosearch);
  if ($whichtype == 'links') $thelink = new onelink('row', $row); 
  else if ($whichtype == 'comments') $thelink = new comment('row', $row); 
  if ($whichtype == 'links') 
  {
   $results .= linkreplacements($searchbody, $thelink); 
  }
  else if ($whichtype == 'categories') $results .= categoryreplacements($searchbody, $thelink); 
  else if ($whichtype == 'comments') $results .= commentreplacements($searchbody, $thelink);     
 }  
 if ($numresults > 0)
 {
  $template->replace('{RESULTS}', $results);
 }
 else
  $template->replace('{RESULTS}', '');
  if ($searchfields[0] == 'ownerid')
  {
   $getname = new member('id', $search);
   $search = $getname->name;
  }
  $language->search_found = str_replace('{SEARCHTERM}', $search, $language->search_found);  
  if ($numresults == '')
    $template->replace('{LANG_SEARCH_FOUND}', str_replace('{NUMRESULTS}', '0', $language->search_found));
  else
    $template->replace('{LANG_SEARCH_FOUND}', str_replace('{NUMRESULTS}', $numresults, $language->search_found));	

 $template->replace('{SEARCHTERM}', $search);  
  
 $numpages = ceil($numresults / $perpage);
 $search = urlencode($search);
 for ($count=1; $count < $page; $count++)
   $previouspages .= $language->pageselection_left. "<a href=search.php?page=$count&perpage=$perpage&search=$search>$count</a>". $language->pageselection_right;
 for ($count=$page; $count<$numpages; $count++)
 {
    $next = $count+1;
    $nextpages .= $language->pageselection_left ."<a href=search.php?page=$next&perpage=$perpage&search=$search>$next</a>". $language->pageselection_right;
 }

 $template->replace('{PREVIOUS}', $previouspages);
 $template->replace('{NEXT}', $nextpages);
 $template->replace('{CURRENTPAGE}', $page);
 $template->replace('{PAGE}', $page);
 $template->replace('{PERPAGE}', $perpage);
}    
require 'end.php';
?> 